> This page is for API Reference.

> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docs.navipartner.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.navipartner.com/_mcp/server.

# Authorize Points Transaction

POST https://api.npretail.app/{tenant}/{environment}/{company}/membership/{membershipId}/points/reserve
Content-Type: application/json

Creates an authorization for a points withdrawal or deposit. This reserves the points for a specified period and must be finalized.

Reference: https://docs.navipartner.com/apis/api-reference/memberships/service-points/authorize-points

## Authentication

- `x-np-api-key` header (required) — API Key authentication via header

## Request

### Path parameters

- `tenant` (string, required) — Your Entra Tenant ID. [More details.](/paths#1-tenant)
- `environment` (string, required) — Your Business Central Environment. [More details.](/paths#2-environment)
- `company` (string, required) — Your Business Central Company. [More details.](/paths#3-company)
- `membershipId` (UUID, required) — Unique identifier for a membership.

### Body (application/json)

This endpoint expects an AuthorizePointsRequest.

- `requestId` (UUID, required) — A unique identifier for the request. If you send the same requestId twice, it will be guaranteed to only trigger once.
- `type` (enum, required) — The type of the request.
  - Allowed values: `DEPOSIT`, `WITHDRAW`
- `pointsToReserve` (integer, required) — The positive number of points to reserve. Set type to withdrawal to deduct points.
- `reason` (string, required) — A description of why the points are being reserved.
- `externalReferenceNo` (string, required) — Your external reference number, such as a POS Receipt number, invoice number etc.
- `externalSystemIdentifier` (string, required) — An identifier of your external system. This together with the entra app name identifies the external system that is making the operation.
- `timeoutPeriod` (integer, optional) — The duration in minutes for which the authorization is valid.
- `externalSystemUserIdentifier` (string, optional) — An identifier for the user in the external system, e.g. a POS UnitId, a salesperson code in an external POS or a user ID in a customer support tool.
- `externalBusinessUnitIdentifier` (string, optional) — An identifier for the business unit of the external system.
- `tags` (list of Tag, optional) — Optional metadata tags to store additional context about the transaction (e.g., sales channel, campaign, reference numbers)

## Response

### 200

- `authorizationCode` (string, required) — A unique identifier for a points transaction to be used for Finalize or Cancel the points transaction. Will not be returned if autoFinalize is set to true.
- `expiresAt` (datetime, required) — The date and time when the authorization expires if a timeoutPeriod is specified in the request.

## Types

### Tag

A key-value pair for storing additional metadata about a transaction.

- `key` (string, required) — The tag identifier (e.g., SALES-CHANNEL, REF-NO, CAMPAIGN)
- `value` (string, required) — The tag value

## Examples

**Request**

```json
{
  "requestId": "11aa22bb-33cc-44dd-55ee-66ff77aa88bb",
  "type": "WITHDRAW",
  "pointsToReserve": 200,
  "reason": "Payment in POS sale",
  "externalReferenceNo": "RCPT-582399102",
  "externalSystemIdentifier": "BCTenant-POSStore",
  "timeoutPeriod": 300,
  "externalSystemUserIdentifier": "SalespersonCode",
  "externalBusinessUnitIdentifier": "My businesss unit",
  "tags": [
    {
      "key": "SALES-CHANNEL",
      "value": "WEB"
    },
    {
      "key": "REF-NO",
      "value": "W23456782"
    },
    {
      "key": "CAMPAIGN",
      "value": "BLACK FRIDAY"
    }
  ]
}
```

**Response**

```json
{
  "authorizationCode": "362FB68C444E41D691FF19EE470B30A1",
  "expiresAt": "2025-06-23T12:05:00Z"
}
```

**SDK Code**

```python Authorize a point deduction
import requests

url = "https://api.npretail.app/01234567-89ab-cdef-0123-456789abcdef/production/CRONUS%2520International%2520Ltd./membership/cdef7890-abcd-0123-1234-567890abcdef/points/reserve"

payload = {
    "requestId": "11aa22bb-33cc-44dd-55ee-66ff77aa88bb",
    "type": "WITHDRAW",
    "pointsToReserve": 200,
    "reason": "Payment in POS sale",
    "externalReferenceNo": "RCPT-582399102",
    "externalSystemIdentifier": "BCTenant-POSStore",
    "timeoutPeriod": 300,
    "externalSystemUserIdentifier": "SalespersonCode",
    "externalBusinessUnitIdentifier": "My businesss unit",
    "tags": [
        {
            "key": "SALES-CHANNEL",
            "value": "WEB"
        },
        {
            "key": "REF-NO",
            "value": "W23456782"
        },
        {
            "key": "CAMPAIGN",
            "value": "BLACK FRIDAY"
        }
    ]
}
headers = {
    "x-np-api-key": "<NaviPartner API Key>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript Authorize a point deduction
const url = 'https://api.npretail.app/01234567-89ab-cdef-0123-456789abcdef/production/CRONUS%2520International%2520Ltd./membership/cdef7890-abcd-0123-1234-567890abcdef/points/reserve';
const options = {
  method: 'POST',
  headers: {'x-np-api-key': '<NaviPartner API Key>', 'Content-Type': 'application/json'},
  body: '{"requestId":"11aa22bb-33cc-44dd-55ee-66ff77aa88bb","type":"WITHDRAW","pointsToReserve":200,"reason":"Payment in POS sale","externalReferenceNo":"RCPT-582399102","externalSystemIdentifier":"BCTenant-POSStore","timeoutPeriod":300,"externalSystemUserIdentifier":"SalespersonCode","externalBusinessUnitIdentifier":"My businesss unit","tags":[{"key":"SALES-CHANNEL","value":"WEB"},{"key":"REF-NO","value":"W23456782"},{"key":"CAMPAIGN","value":"BLACK FRIDAY"}]}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go Authorize a point deduction
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.npretail.app/01234567-89ab-cdef-0123-456789abcdef/production/CRONUS%2520International%2520Ltd./membership/cdef7890-abcd-0123-1234-567890abcdef/points/reserve"

	payload := strings.NewReader("{\n  \"requestId\": \"11aa22bb-33cc-44dd-55ee-66ff77aa88bb\",\n  \"type\": \"WITHDRAW\",\n  \"pointsToReserve\": 200,\n  \"reason\": \"Payment in POS sale\",\n  \"externalReferenceNo\": \"RCPT-582399102\",\n  \"externalSystemIdentifier\": \"BCTenant-POSStore\",\n  \"timeoutPeriod\": 300,\n  \"externalSystemUserIdentifier\": \"SalespersonCode\",\n  \"externalBusinessUnitIdentifier\": \"My businesss unit\",\n  \"tags\": [\n    {\n      \"key\": \"SALES-CHANNEL\",\n      \"value\": \"WEB\"\n    },\n    {\n      \"key\": \"REF-NO\",\n      \"value\": \"W23456782\"\n    },\n    {\n      \"key\": \"CAMPAIGN\",\n      \"value\": \"BLACK FRIDAY\"\n    }\n  ]\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("x-np-api-key", "<NaviPartner API Key>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby Authorize a point deduction
require 'uri'
require 'net/http'

url = URI("https://api.npretail.app/01234567-89ab-cdef-0123-456789abcdef/production/CRONUS%2520International%2520Ltd./membership/cdef7890-abcd-0123-1234-567890abcdef/points/reserve")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["x-np-api-key"] = '<NaviPartner API Key>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"requestId\": \"11aa22bb-33cc-44dd-55ee-66ff77aa88bb\",\n  \"type\": \"WITHDRAW\",\n  \"pointsToReserve\": 200,\n  \"reason\": \"Payment in POS sale\",\n  \"externalReferenceNo\": \"RCPT-582399102\",\n  \"externalSystemIdentifier\": \"BCTenant-POSStore\",\n  \"timeoutPeriod\": 300,\n  \"externalSystemUserIdentifier\": \"SalespersonCode\",\n  \"externalBusinessUnitIdentifier\": \"My businesss unit\",\n  \"tags\": [\n    {\n      \"key\": \"SALES-CHANNEL\",\n      \"value\": \"WEB\"\n    },\n    {\n      \"key\": \"REF-NO\",\n      \"value\": \"W23456782\"\n    },\n    {\n      \"key\": \"CAMPAIGN\",\n      \"value\": \"BLACK FRIDAY\"\n    }\n  ]\n}"

response = http.request(request)
puts response.read_body
```

```java Authorize a point deduction
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://api.npretail.app/01234567-89ab-cdef-0123-456789abcdef/production/CRONUS%2520International%2520Ltd./membership/cdef7890-abcd-0123-1234-567890abcdef/points/reserve")
  .header("x-np-api-key", "<NaviPartner API Key>")
  .header("Content-Type", "application/json")
  .body("{\n  \"requestId\": \"11aa22bb-33cc-44dd-55ee-66ff77aa88bb\",\n  \"type\": \"WITHDRAW\",\n  \"pointsToReserve\": 200,\n  \"reason\": \"Payment in POS sale\",\n  \"externalReferenceNo\": \"RCPT-582399102\",\n  \"externalSystemIdentifier\": \"BCTenant-POSStore\",\n  \"timeoutPeriod\": 300,\n  \"externalSystemUserIdentifier\": \"SalespersonCode\",\n  \"externalBusinessUnitIdentifier\": \"My businesss unit\",\n  \"tags\": [\n    {\n      \"key\": \"SALES-CHANNEL\",\n      \"value\": \"WEB\"\n    },\n    {\n      \"key\": \"REF-NO\",\n      \"value\": \"W23456782\"\n    },\n    {\n      \"key\": \"CAMPAIGN\",\n      \"value\": \"BLACK FRIDAY\"\n    }\n  ]\n}")
  .asString();
```

```php Authorize a point deduction
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://api.npretail.app/01234567-89ab-cdef-0123-456789abcdef/production/CRONUS%2520International%2520Ltd./membership/cdef7890-abcd-0123-1234-567890abcdef/points/reserve', [
  'body' => '{
  "requestId": "11aa22bb-33cc-44dd-55ee-66ff77aa88bb",
  "type": "WITHDRAW",
  "pointsToReserve": 200,
  "reason": "Payment in POS sale",
  "externalReferenceNo": "RCPT-582399102",
  "externalSystemIdentifier": "BCTenant-POSStore",
  "timeoutPeriod": 300,
  "externalSystemUserIdentifier": "SalespersonCode",
  "externalBusinessUnitIdentifier": "My businesss unit",
  "tags": [
    {
      "key": "SALES-CHANNEL",
      "value": "WEB"
    },
    {
      "key": "REF-NO",
      "value": "W23456782"
    },
    {
      "key": "CAMPAIGN",
      "value": "BLACK FRIDAY"
    }
  ]
}',
  'headers' => [
    'Content-Type' => 'application/json',
    'x-np-api-key' => '<NaviPartner API Key>',
  ],
]);

echo $response->getBody();
```

```csharp Authorize a point deduction
using RestSharp;

var client = new RestClient("https://api.npretail.app/01234567-89ab-cdef-0123-456789abcdef/production/CRONUS%2520International%2520Ltd./membership/cdef7890-abcd-0123-1234-567890abcdef/points/reserve");
var request = new RestRequest(Method.POST);
request.AddHeader("x-np-api-key", "<NaviPartner API Key>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"requestId\": \"11aa22bb-33cc-44dd-55ee-66ff77aa88bb\",\n  \"type\": \"WITHDRAW\",\n  \"pointsToReserve\": 200,\n  \"reason\": \"Payment in POS sale\",\n  \"externalReferenceNo\": \"RCPT-582399102\",\n  \"externalSystemIdentifier\": \"BCTenant-POSStore\",\n  \"timeoutPeriod\": 300,\n  \"externalSystemUserIdentifier\": \"SalespersonCode\",\n  \"externalBusinessUnitIdentifier\": \"My businesss unit\",\n  \"tags\": [\n    {\n      \"key\": \"SALES-CHANNEL\",\n      \"value\": \"WEB\"\n    },\n    {\n      \"key\": \"REF-NO\",\n      \"value\": \"W23456782\"\n    },\n    {\n      \"key\": \"CAMPAIGN\",\n      \"value\": \"BLACK FRIDAY\"\n    }\n  ]\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift Authorize a point deduction
import Foundation

let headers = [
  "x-np-api-key": "<NaviPartner API Key>",
  "Content-Type": "application/json"
]
let parameters = [
  "requestId": "11aa22bb-33cc-44dd-55ee-66ff77aa88bb",
  "type": "WITHDRAW",
  "pointsToReserve": 200,
  "reason": "Payment in POS sale",
  "externalReferenceNo": "RCPT-582399102",
  "externalSystemIdentifier": "BCTenant-POSStore",
  "timeoutPeriod": 300,
  "externalSystemUserIdentifier": "SalespersonCode",
  "externalBusinessUnitIdentifier": "My businesss unit",
  "tags": [
    [
      "key": "SALES-CHANNEL",
      "value": "WEB"
    ],
    [
      "key": "REF-NO",
      "value": "W23456782"
    ],
    [
      "key": "CAMPAIGN",
      "value": "BLACK FRIDAY"
    ]
  ]
] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api.npretail.app/01234567-89ab-cdef-0123-456789abcdef/production/CRONUS%2520International%2520Ltd./membership/cdef7890-abcd-0123-1234-567890abcdef/points/reserve")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```